#include <stdio.h>
#include <string.h>

char word7[128], word24[128], trans[64],
		line24[32000], line7[32000];

char trans1[64], trans2[64], trans3[64], trans4[64],		/* transcriptions  */
	 trans5[64], trans6[64], trans7[64], trans8[64];

char part1[10], part2[10], part3[10], part4[10],		/* small parts of  "line7"  for compare */
	 part5[10], part6[10], part7[10], part8[10];

char partt1[16000], partt2[16000], partt3[16000], partt4[16000],		/*  parts of  "line24"  */
	 partt5[16000], partt6[16000], partt7[16000], partt8[16000];

char trn[64];
char prt[10];
char partt[16000];

int  sw, wr, s;

/**************************************************************************************************/
void text (void)
{  printf ("\n\n                  RUSSIAN\n\n"\
	" Skopiruite slovari \"Mueller7GPL\" s transkripciei  i \"Mueller24\"\n"\
	" v Vashu domashniu direktoriu. Pereimenuite ih v \"muller7.txt\"\n"\
	" i \"muller24.txt\" sootvetstvenno. V etu je direktoriu polojite programmu\n"\
	" \"transperenos\" i zapustite ee. Budet sozdan novi slovar pod nazvaniem\n"\
	" \"muller36.txt\" v kotorom budut vse stroki slovaria \"muller24.txt\" so\n"\
	" vstavlennimi transkripciami iz slovaria \"muller7.txt\".\n"\
	" Vi mojete skompilirovat programu sami nabrav v terminale : \n"\
	"        gcc -Wall -o transperenos transperenos.c  \n\n\n");
}
/**************************************************************************************************/
void make_null_all ( void )
{ 	trans1[0] = '\0'; trans2[0] = '\0'; trans3[0] = '\0'; trans4[0] = '\0';	/* transcriptions  */
	trans5[0] = '\0'; trans6[0] = '\0'; trans7[0] = '\0'; trans8[0] = '\0';
	partt1[0] = '\0'; partt2[0] = '\0'; partt3[0] = '\0'; partt4[0] = '\0';		/*  parts of  "line24"  */
	partt5[0] = '\0'; partt6[0] = '\0'; partt7[0] = '\0'; partt8[0] = '\0';
	trn[0] = '\0'; prt[0] = '\0';
	partt[0] = '\0'; line24[0]='\0';
}
/************************************************************************************************/
int get_w7 (void)
{  int i,w;
	for(i=0; line7[i]!='\0'; ++i )
	{	if (line7[i-1]==' '&&line7[i]==' ')
		{	for(w=0; w<i; w++) word7[w]=line7[w];		/* get  word7 */
			word7[w-1]='\0';
			break;
		}
	}
	return 0;
}
/***********************************************************************************/
char *get_trans ( int f, int j )
{ int w;
	for(w=0; w<j-f; w++) trn[w]=line7[f+w]; /* for */
	trn[0]=' ';
	trn[w]='\0';
	return trn ;
}
/**********************************************************/
char *get_part ( int f )
{ int w;
	for(w=0; w<9; w++) prt[w]=line7[f+w]; /* for */
	prt[w]='\0';
	return prt;
}
/**********************************************************************/
int get_w7_trans (void)
{  int i, f=0 ;
	sw=0; s=0;
	for(i=0; line7[i]!='\0'; ++i )
	{	if (line7[i-2]==' '&&line7[i-1]==' '&&line7[i]=='[') { s= -1; sw=1; } /* first transcription found */
		if (line7[i]=='[')
		{	if (s== -1) f=i-1;				/* if first transcription found */
			if (s==0||s== -2) { f=i-1; s=1; }		/* if not trans (or was) then trans1 */
			if (s==3) { f=i-1; s=4; }
			if (s==6) { f=i-1; s=7; }
			if (s==9) { f=i-1; s=10; }
			if (s==12) { f=i-1; s=13; }
			if (s==15) { f=i-1; s=16; }
			if (s==18) { f=i-1; s=19; }
			if (s==21) { f=i-1; s=22; }
		}

		if (line7[i-1]==']')
		{	if (s== -1) { strcpy(trans, get_trans(f, i)); s= -2; f=i; }		/*    trans   */
			if (s==1) { strcpy(trans1, get_trans(f, i)); s=2; f=i; }		/* trans1 */
			if (s==4) { strcpy(trans2, get_trans(f, i)); s=5; f=i; }			/* trans2 */
			if (s==7) { strcpy(trans3, get_trans(f, i)); s=8; f=i; }		/* trans3*/
			if (s==10) { strcpy(trans4, get_trans(f, i)); s=11; f=i; }	/* trans4*/
			if (s==13) { strcpy(trans5, get_trans(f, i)); s=14; f=i; }	/* trans5*/
			if (s==16) { strcpy(trans6, get_trans(f, i)); s=17; f=i; }	/* trans6*/
			if (s==19) { strcpy(trans7, get_trans(f, i)); s=20; f=i; }	/* trans7*/
			if (s==22) { strcpy(trans8, get_trans(f, i)); s=23; f=i; }	/* trans8*/
		}

		if (line7[i-10]==']')
		{	if (s==2) { strcpy(part1, get_part(f) ); s=3; }			/* part1  */
			if (s==5) { strcpy(part2, get_part(f) ); s=6; }			/* part2  */
			if (s==8) { strcpy(part3, get_part(f) ); s=9; }			/* part3  */
			if (s==11) {strcpy(part4, get_part(f) ); s=12; }			/* part4  */
			if (s==14) {strcpy(part5, get_part(f) ); s=15; }			/* part5  */
			if (s==17) {strcpy(part6, get_part(f) ); s=18; }			/* part6  */
			if (s==20) {strcpy(part7, get_part(f) ); s=21; }			/* part7  */
			if (s==23) {strcpy(part8, get_part(f) ); s=24; break; }		/* part8  */
		}
	}
		return s;
}
/********************************************************************/
char *get_24_part (char par[] )
{int i, w;
	wr=1;
	for(i=0; line24[i]!='\0'; i++)
	{	{ if(par[0]==line24[i-9])
		 { if(par[1]==line24[i-8])
		  { if(par[2]==line24[i-7])
		   { if(par[3]==line24[i-6])
		    { if(par[4]==line24[i-5])
		     { if(par[5]==line24[i-4])
		      { if(par[6]==line24[i-3])
		       { if(par[7]==line24[i-2])
		        { if(par[8]==line24[i-1])
		          {	if (i<10) { partt[0]='\0'; return partt; }	/* if  part  equallies to part before - quit */
				for(w=0; w<(i-9); w++) partt[w]=line24[w]; /*for*/
				partt[i-9]='\0';
				for(w=0; w<32000; w++)
				{	line24[w]=line24[i-9+w];
					if(line24[w]=='\0')
					{	wr=0;
						return partt;
					}
				}/*for*/
		}}}}}}}}}}
	}/*for*/
	partt[0]='\0';
	return partt;
}
/********************************************************************/
int compile_24 (void )
{ int i, w, f=0;

	if (s==0) return s;
	for(i=0; line24[i]!='\0'; i++)
	{	if(line24[i-1]==' '&&line24[i]==' ') f=i; } /*for*/
	if (f !=0)
	{	for(w=0; line24!='\0'; w++)
		{	line24[w]=line24[f+w];
			if (line24[f+w-1]=='\n')
			{	line24[w]='\0';
				break;
			}
		}/*for*/
	}

	if (s==3)
	{	 strcpy( partt1, get_24_part(part1)); if(wr) trans1[0]='\0';
	}
	else if (s==6)
	{	strcpy( partt1, get_24_part(part1)); if(wr) trans1[0]='\0';
		strcpy( partt2, get_24_part(part2)); if(wr) trans2[0]='\0';
	}
	else if (s==9)
	{	strcpy( partt1, get_24_part(part1)); if(wr) trans1[0]='\0';
		strcpy( partt2, get_24_part(part2)); if(wr) trans2[0]='\0';
		strcpy( partt3, get_24_part(part3)); if(wr) trans3[0]='\0';
	}
	else if (s==12)
	{	strcpy( partt1, get_24_part(part1)); if(wr) trans1[0]='\0';
		strcpy( partt2, get_24_part(part2)); if(wr) trans2[0]='\0';
		strcpy( partt3, get_24_part(part3)); if(wr) trans3[0]='\0';
		strcpy( partt4, get_24_part(part4)); if(wr) trans4[0]='\0';
	}
	else if (s==15)
	{	strcpy( partt1, get_24_part(part1)); if(wr) trans1[0]='\0';
		strcpy( partt2, get_24_part(part2)); if(wr) trans2[0]='\0';
		strcpy( partt3, get_24_part(part3)); if(wr) trans3[0]='\0';
		strcpy( partt4, get_24_part(part4)); if(wr) trans4[0]='\0';
		strcpy( partt5, get_24_part(part5)); if(wr) trans5[0]='\0';
	}
	else if (s==18)
	{	strcpy( partt1, get_24_part(part1)); if(wr) trans1[0]='\0';
		strcpy( partt2, get_24_part(part2)); if(wr) trans2[0]='\0';
		strcpy( partt3, get_24_part(part3)); if(wr) trans3[0]='\0';
		strcpy( partt4, get_24_part(part4)); if(wr) trans4[0]='\0';
		strcpy( partt5, get_24_part(part5)); if(wr) trans5[0]='\0';
		strcpy( partt6, get_24_part(part6)); if(wr) trans6[0]='\0';
	}
	else if (s==21)
	{	strcpy( partt1, get_24_part(part1)); if(wr) trans1[0]='\0';
		strcpy( partt2, get_24_part(part2)); if(wr) trans2[0]='\0';
		strcpy( partt3, get_24_part(part3)); if(wr) trans3[0]='\0';
		strcpy( partt4, get_24_part(part4)); if(wr) trans4[0]='\0';
		strcpy( partt5, get_24_part(part5)); if(wr) trans5[0]='\0';
		strcpy( partt6, get_24_part(part6)); if(wr) trans6[0]='\0';
		strcpy( partt7, get_24_part(part7)); if(wr) trans7[0]='\0';
	}
	else if (s==24)
	{	strcpy( partt1, get_24_part(part1)); if(wr) trans1[0]='\0';
		strcpy( partt2, get_24_part(part2)); if(wr) trans2[0]='\0';
		strcpy( partt3, get_24_part(part3)); if(wr) trans3[0]='\0';
		strcpy( partt4, get_24_part(part4)); if(wr) trans4[0]='\0';
		strcpy( partt5, get_24_part(part5)); if(wr) trans5[0]='\0';
		strcpy( partt6, get_24_part(part6)); if(wr) trans6[0]='\0';
		strcpy( partt7, get_24_part(part7)); if(wr) trans7[0]='\0';
		strcpy( partt8, get_24_part(part8)); if(wr) trans8[0]='\0';
	}
			return s;
}
/**********************************************************************************************/
int get_w24 (void)
{   int i,w;
	for(i=0; i<128; ++i )
	{	if (line24[i-1]==' '&&line24[i]==' ')
		 {	for(w=0; w<i; w++)
		 	word24[w]=line24[w];
		 	word24[i-1]='\0';
			break;
		 }
	}
	    return 0;
}
/***************************************************************************/
int repare_symb ( int c)
{	           if (c=='_') c=35;
	    else if (c=='.') c=62;
	    else if (c=='/') c=63;
	    else if (c>64&&c<91) c=c+32;
	    return c ;
}
/**********************************************************************/
int compare_words ( char word1[], char word2[] )
{     int i ; char comp1[128], comp2[128];
		for(i=0;i<128;i++) { comp1[i]='\0'; comp2[i]='\0'; }
	for(i=0; i<128 ; i++)
	{    comp1[i] = repare_symb(word1[i]) ;
	     comp2[i] = repare_symb(word2[i]) ;
		       if (comp1[i]<comp2[i]) return (-1);
		else if (comp1[i]=='\0'&& comp2[i]=='\0'&& i>0) return 1;
	 	else if (comp1[i]>comp2[i]) return 2;
	} 		return 0;
}
/***************************************************************/
int main ( int argc, char *argv[])
{	int  p, k, h=32000;
	FILE *muller7, *muller24, *muller36;

	if (argc>1) { text(); return 0; }
		if ((muller7 = fopen("muller7.txt","r")) == NULL ) {
			 printf ("\n\033[1;40;32m Can't open  \033[1;40;33m"\
			 "\"muller7.txt\"\033[1;40;32m  or file doesn't exist\033[0m\n\n");
			 return 0; }
		if ((muller24 = fopen("muller24.txt","r")) == NULL ) {
			 printf ("\n\033[1;40;32m Can't open  \033[1;40;33m"\
			 "\"muller24.txt\"\033[1;40;32m  or file doesn't exist\033[0m\n\n");
			 return 0; }
		if ((muller36 = fopen("muller36.txt","w")) == NULL ) {
			printf ("\n\033[1;40;32m Can't create/write  \033[1;40;33m"\
			 "\"muller36.txt\"\033[1;40;32m  access denied ?\033[0m\n\n");
			 return 0; }
		printf ( "\n\033[1;40;32m  Creating in progress ...  please wait \n"\
			"     it can take a few minutes\033[0m\n" );

	while ( fgets (line24,h,muller24))/***********  getting next line from muller24  ******while*******/
	{	get_w24();					/* getting  word24  */
		p = compare_words(word7, word24);

		k=0;
		while(p== -1)
		{	if (!fgets(line7,h,muller7)) { k=1; break;  }	/* !!!  getting line from muller7  */
			get_w7 ();			/* getting word7  */
			p = compare_words( word7, word24);
		}/* while */

		if (p==1)
		{
			get_w7_trans();			/* getting all trans & parts  */
			compile_24();				/* getting line24 & parTTs */

			if (s==0) fprintf(muller36,"%s", line24 );
			else
			{	if (sw==0) fprintf (muller36,"%s ", word24);
				if (sw==1) fprintf (muller36,"%s %s", word24, trans);
				fprintf (muller36,"%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s",
					partt1, trans1, partt2, trans2, partt3, trans3, partt4, trans4, partt5, trans5,
					partt6, trans6, partt7, trans7, partt8, trans8, line24 );
			}
		}
		else if (p==2||k==1) fprintf (muller36,"%s", line24 );
		make_null_all();
	}/** while *****************************while*************while**********/

			fclose(muller7); fclose(muller24); fclose(muller36);
			printf("\n              \033[1;40;33mDone\033[0m\n\n");
			return 0;
}
/****************************************************************************************/
